HanchengZhao / algorithm-notes

0 stars 0 forks source link

Leetcode568.Maximum Vacation Days 6.8.2017 #3

Open YeWang0 opened 7 years ago

YeWang0 commented 7 years ago

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday. The cities are connected by flights. The flights are represented as a NN matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time. For each city, you can only have restricted vacation days in different weeks, given an NK matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j. You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

YeWang0 commented 7 years ago

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]] Output: 12 Explanation: Ans = 6 + 3 + 3 = 12.

One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day. (Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

YeWang0 commented 7 years ago

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]] Output: 3 Explanation: Ans = 1 + 1 + 1 = 3.

Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks. For each week, you only have one day to play and six days to work. So the maximum number of vacation days is 3.

YeWang0 commented 7 years ago

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]] Output: 21 Explanation: Ans = 7 + 7 + 7 = 21

One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

YeWang0 commented 7 years ago

Note:

N and K are positive integers, which are in the range of [1, 100]. In the matrix days, all the values are integers in the range of [0, 1]. In the matrix flights, all the values are integers in the range [0, 7]. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week. We don't consider the impact of flight hours towards the calculation of vacation days.

YeWang0 commented 7 years ago

Solution 1:DPS

YeWang0 commented 7 years ago

Consider this problem as a minimum path in a graph from week 1 to week k. The path is the flight path between different cities within k days, one flight in each week.

YeWang0 commented 7 years ago

(n cities, k weeks) -> n^k paths in maximum (if all cities connected)

YeWang0 commented 7 years ago

Since it is a search problem and needs all possible paths, DFS could be the one.

YeWang0 commented 7 years ago

Time complexity: O(n^k) (the number of paths) Space complexity: O(k) (the length of a path)

YeWang0 commented 7 years ago

Solution 2: DP

YeWang0 commented 7 years ago

why DP? State of week[i+1] only depend on state of week[i] dp[i][j] stand for the state(vacation days in total for now) of week i at city j dp[i][j]=dp[i-1][x]+day[j][i] where there is flight from x to j or x==j, day[j][i] means the vacation days of week i at city j Initization: dp[0][j]=day[j][0] if there is flight from 0 to j or j==0 else dp[0][j]=-1(unreachable state) so, for all dp[i][j] should be initialized as -1(or something) at first to mark them as unreachable. only update states from dp[i-1][x] where it is >=0

YeWang0 commented 7 years ago

Time complexity: O(nk) (the number of states) Space complexity: O(n*n\k) (updating of state takes O(n))

HanchengZhao commented 7 years ago

We know it starts with city 0 and week 1, but have no clue where it ends. Thus, using dp in a backward way and returning dp[0][0] would be a good solution.

class Solution(object):
    def maxVacationDays(self, flights, days):
        """
        :type flights: List[List[int]]
        :type days: List[List[int]]
        :rtype: int
        """
        if not flights or not days:
            return 0
        weekslen = len(days[0])
        dp = [[0] * (weekslen + 1) for i in xrange(len(days))]
        for week in xrange(weekslen-1, -1, -1):
            for cur_city in xrange(len(days)):
                dp[cur_city][week] = days[cur_city][week] + dp[cur_city][week + 1]
                for dest_city in xrange(len(days)):
                    if flights[cur_city][dest_city] == 1:
                        dp[cur_city][week] = max(days[dest_city][week] + dp[dest_city][week + 1], dp[cur_city][week])
        return dp[0][0]